/* eslint-disable prefer-promise-reject-errors */
/* eslint-disable no-throw-literal */
// const logger = require('utils/logger');
const templateService = require('../template/service');
const logger = require('../utils/logger'); 

const updateAndMapWidget = async (page, widgetId, position, startTime, endTime,templateId) => {
  try {
    logger.info(`Business Logic | updateAndMapWidget | Page: ${page}, Widget ID: ${widgetId}`);
    const response = await templateService.updateAndMapWidget(page, widgetId, position, startTime, endTime,templateId);
    
    logger.info(`Widget mapping updated | Widget ID: ${widgetId} | Page: ${page}`);
    return { status: 200, data: response };
  } catch (error) {
    logger.error(`Error in Business Logic updateAndMapWidget: ${error.message}`);
    throw error;
  }
};


const createTemplate = async (name, desc, platform, widgets, hashId) => {
  try {
    logger.info(`Business logic: creating template for platform=${platform}`);
    
    const response = await templateService.createTemplate(name, desc, platform, widgets, hashId);
    
    return { status: 201, response };
  } catch (error) {
    logger.error(`Error in business logic: ${error.message}`, { error });
    throw error;
  }
};


const getParticularTemplate = async (page,platform) => {
  try {
    const response = await templateService.getParticularTemplate(page,platform);
    if (response.length == 0) {
      return { status: 404, message: "Template not found" };
    }
    return { status: '200', response }
  } catch (error) {
    throw error
  }

};


module.exports = {
  updateAndMapWidget,
  createTemplate,
  getParticularTemplate
};
