/* eslint-disable prefer-promise-reject-errors */
/* eslint-disable no-throw-literal */
// const logger = require('utils/logger');
const widgetService = require('./service');
const logger = require('../utils/logger'); 




const getAllWidget = async (page) => {
  try {
    logger.info(`Business logic: Getting widgets for page ${page}`);
    
    const response = await widgetService.getAllWidget(page);
    return { status: 200, data: response };
  } catch (error) {
    logger.error(`Error in business logic: ${error.message}`);
    throw new Error('Failed to fetch widgets');
  }
};



const createWidget = async (data) => {
  try {
    logger.info('Business Logic: Creating widget'); // Log business logic activity
    const response = await widgetService.createWidget(data);

    return { status: 200, response };
  } catch (error) {
    logger.error(`Error in business logic: ${error.message}`); // Log error
    throw error; // Pass the error to the controller
  }
};



module.exports = {
  getAllWidget,
  createWidget,
};
